" Copyright (c) 2015 Junegunn Choi
"
" MIT License
"
" Permission is hereby granted, free of charge, to any person obtaining
" a copy of this software and associated documentation files (the
" "Software"), to deal in the Software without restriction, including
" without limitation the rights to use, copy, modify, merge, publish,
" distribute, sublicense, and/or sell copies of the Software, and to
" permit persons to whom the Software is furnished to do so, subject to
" the following conditions:
"
" The above copyright notice and this permission notice shall be
" included in all copies or substantial portions of the Software.
"
" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
" EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
" NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
" LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
" OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
" WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

let s:emoji_code = {
    \ '+1': 0x1f44d,
    \ '-1': 0x1f44e,
    \ '100': 0x1f4af,
    \ '1234': 0x1f522,
    \ '8ball': 0x1f3b1,
    \ 'a': 0x1f170,
    \ 'ab': 0x1f18e,
    \ 'abc': 0x1f524,
    \ 'abcd': 0x1f521,
    \ 'accept': 0x1f251,
    \ 'admission_tickets': 0x1f39f,
    \ 'adult': 0x1f9d1,
    \ 'aerial_tramway': 0x1f6a1,
    \ 'airplane': 0x2708,
    \ 'airplane_arriving': 0x1f6ec,
    \ 'airplane_departure': 0x1f6eb,
    \ 'alarm_clock': 0x23f0,
    \ 'alembic': 0x2697,
    \ 'alien': 0x1f47d,
    \ 'ambulance': 0x1f691,
    \ 'amphora': 0x1f3fa,
    \ 'anchor': 0x2693,
    \ 'angel': 0x1f47c,
    \ 'anger': 0x1f4a2,
    \ 'angry': 0x1f620,
    \ 'anguished': 0x1f627,
    \ 'ant': 0x1f41c,
    \ 'apple': 0x1f34e,
    \ 'aquarius': 0x2652,
    \ 'aries': 0x2648,
    \ 'arrow_backward': 0x25c0,
    \ 'arrow_double_down': 0x23ec,
    \ 'arrow_double_up': 0x23eb,
    \ 'arrow_down': 0x2b07,
    \ 'arrow_down_small': 0x1f53d,
    \ 'arrow_forward': 0x25b6,
    \ 'arrow_heading_down': 0x2935,
    \ 'arrow_heading_up': 0x2934,
    \ 'arrow_left': 0x2b05,
    \ 'arrow_lower_left': 0x2199,
    \ 'arrow_lower_right': 0x2198,
    \ 'arrow_right': 0x27a1,
    \ 'arrow_right_hook': 0x21aa,
    \ 'arrow_up': 0x2b06,
    \ 'arrow_up_down': 0x2195,
    \ 'arrow_up_small': 0x1f53c,
    \ 'arrow_upper_left': 0x2196,
    \ 'arrow_upper_right': 0x2197,
    \ 'arrows_clockwise': 0x1f503,
    \ 'arrows_counterclockwise': 0x1f504,
    \ 'art': 0x1f3a8,
    \ 'articulated_lorry': 0x1f69b,
    \ 'astonished': 0x1f632,
    \ 'athletic_shoe': 0x1f45f,
    \ 'atm': 0x1f3e7,
    \ 'atom_symbol': 0x269b,
    \ 'avocado': 0x1f951,
    \ 'b': 0x1f171,
    \ 'baby': 0x1f476,
    \ 'baby_bottle': 0x1f37c,
    \ 'baby_chick': 0x1f424,
    \ 'baby_symbol': 0x1f6bc,
    \ 'back': 0x1f519,
    \ 'bacon': 0x1f953,
    \ 'badminton_racquet_and_shuttlecock': 0x1f3f8,
    \ 'baggage_claim': 0x1f6c4,
    \ 'baguette_bread': 0x1f956,
    \ 'balloon': 0x1f388,
    \ 'ballot_box_with_ballot': 0x1f5f3,
    \ 'ballot_box_with_check': 0x2611,
    \ 'bamboo': 0x1f38d,
    \ 'banana': 0x1f34c,
    \ 'bangbang': 0x203c,
    \ 'bank': 0x1f3e6,
    \ 'bar_chart': 0x1f4ca,
    \ 'barber': 0x1f488,
    \ 'barely_sunny': 0x1f325,
    \ 'baseball': 0x26be,
    \ 'basketball': 0x1f3c0,
    \ 'bat': 0x1f987,
    \ 'bath': 0x1f6c0,
    \ 'bathtub': 0x1f6c1,
    \ 'battery': 0x1f50b,
    \ 'beach_with_umbrella': 0x1f3d6,
    \ 'bear': 0x1f43b,
    \ 'bearded_person': 0x1f9d4,
    \ 'bed': 0x1f6cf,
    \ 'bee': 0x1f41d,
    \ 'beer': 0x1f37a,
    \ 'beers': 0x1f37b,
    \ 'beetle': 0x1f41e,
    \ 'beginner': 0x1f530,
    \ 'bell': 0x1f514,
    \ 'bellhop_bell': 0x1f6ce,
    \ 'bento': 0x1f371,
    \ 'bicyclist': 0x1f6b4,
    \ 'bike': 0x1f6b2,
    \ 'bikini': 0x1f459,
    \ 'billed_cap': 0x1f9e2,
    \ 'biohazard_sign': 0x2623,
    \ 'bird': 0x1f426,
    \ 'birthday': 0x1f382,
    \ 'black_circle': 0x26ab,
    \ 'black_circle_for_record': 0x23fa,
    \ 'black_heart': 0x1f5a4,
    \ 'black_joker': 0x1f0cf,
    \ 'black_large_square': 0x2b1b,
    \ 'black_left_pointing_double_triangle_with_vertical_bar': 0x23ee,
    \ 'black_medium_small_square': 0x25fe,
    \ 'black_medium_square': 0x25fc,
    \ 'black_nib': 0x2712,
    \ 'black_right_pointing_double_triangle_with_vertical_bar': 0x23ed,
    \ 'black_right_pointing_triangle_with_double_vertical_bar': 0x23ef,
    \ 'black_small_square': 0x25aa,
    \ 'black_square_button': 0x1f532,
    \ 'black_square_for_stop': 0x23f9,
    \ 'blond-haired-man': [0x1f471, 0x200d, 0x2642],
    \ 'blond-haired-woman': [0x1f471, 0x200d, 0x2640],
    \ 'blossom': 0x1f33c,
    \ 'blowfish': 0x1f421,
    \ 'blue_book': 0x1f4d8,
    \ 'blue_car': 0x1f699,
    \ 'blue_heart': 0x1f499,
    \ 'blush': 0x1f60a,
    \ 'boar': 0x1f417,
    \ 'boat': 0x26f5,
    \ 'bomb': 0x1f4a3,
    \ 'book': 0x1f4d6,
    \ 'bookmark': 0x1f516,
    \ 'bookmark_tabs': 0x1f4d1,
    \ 'books': 0x1f4da,
    \ 'boom': 0x1f4a5,
    \ 'boot': 0x1f462,
    \ 'bouquet': 0x1f490,
    \ 'bow': 0x1f647,
    \ 'bow_and_arrow': 0x1f3f9,
    \ 'bowl_with_spoon': 0x1f963,
    \ 'bowling': 0x1f3b3,
    \ 'boxing_glove': 0x1f94a,
    \ 'boy': 0x1f466,
    \ 'brain': 0x1f9e0,
    \ 'bread': 0x1f35e,
    \ 'breast-feeding': 0x1f931,
    \ 'bride_with_veil': 0x1f470,
    \ 'bridge_at_night': 0x1f309,
    \ 'briefcase': 0x1f4bc,
    \ 'broccoli': 0x1f966,
    \ 'broken_heart': 0x1f494,
    \ 'bug': 0x1f41b,
    \ 'building_construction': 0x1f3d7,
    \ 'bulb': 0x1f4a1,
    \ 'bullettrain_front': 0x1f685,
    \ 'bullettrain_side': 0x1f684,
    \ 'burrito': 0x1f32f,
    \ 'bus': 0x1f68c,
    \ 'busstop': 0x1f68f,
    \ 'bust_in_silhouette': 0x1f464,
    \ 'busts_in_silhouette': 0x1f465,
    \ 'butterfly': 0x1f98b,
    \ 'cactus': 0x1f335,
    \ 'cake': 0x1f370,
    \ 'calendar': 0x1f4c6,
    \ 'call_me_hand': 0x1f919,
    \ 'calling': 0x1f4f2,
    \ 'camel': 0x1f42b,
    \ 'camera': 0x1f4f7,
    \ 'camera_with_flash': 0x1f4f8,
    \ 'camping': 0x1f3d5,
    \ 'cancer': 0x264b,
    \ 'candle': 0x1f56f,
    \ 'candy': 0x1f36c,
    \ 'canned_food': 0x1f96b,
    \ 'canoe': 0x1f6f6,
    \ 'capital_abcd': 0x1f520,
    \ 'capricorn': 0x2651,
    \ 'car': 0x1f697,
    \ 'card_file_box': 0x1f5c3,
    \ 'card_index': 0x1f4c7,
    \ 'card_index_dividers': 0x1f5c2,
    \ 'carousel_horse': 0x1f3a0,
    \ 'carrot': 0x1f955,
    \ 'cat': 0x1f431,
    \ 'cat2': 0x1f408,
    \ 'cd': 0x1f4bf,
    \ 'chains': 0x26d3,
    \ 'champagne': 0x1f37e,
    \ 'chart': 0x1f4b9,
    \ 'chart_with_downwards_trend': 0x1f4c9,
    \ 'chart_with_upwards_trend': 0x1f4c8,
    \ 'checkered_flag': 0x1f3c1,
    \ 'cheese_wedge': 0x1f9c0,
    \ 'cherries': 0x1f352,
    \ 'cherry_blossom': 0x1f338,
    \ 'chestnut': 0x1f330,
    \ 'chicken': 0x1f414,
    \ 'child': 0x1f9d2,
    \ 'children_crossing': 0x1f6b8,
    \ 'chipmunk': 0x1f43f,
    \ 'chocolate_bar': 0x1f36b,
    \ 'chopsticks': 0x1f962,
    \ 'christmas_tree': 0x1f384,
    \ 'church': 0x26ea,
    \ 'cinema': 0x1f3a6,
    \ 'circus_tent': 0x1f3aa,
    \ 'city_sunrise': 0x1f307,
    \ 'city_sunset': 0x1f306,
    \ 'cityscape': 0x1f3d9,
    \ 'cl': 0x1f191,
    \ 'clap': 0x1f44f,
    \ 'clapper': 0x1f3ac,
    \ 'classical_building': 0x1f3db,
    \ 'clinking_glasses': 0x1f942,
    \ 'clipboard': 0x1f4cb,
    \ 'clock1': 0x1f550,
    \ 'clock10': 0x1f559,
    \ 'clock1030': 0x1f565,
    \ 'clock11': 0x1f55a,
    \ 'clock1130': 0x1f566,
    \ 'clock12': 0x1f55b,
    \ 'clock1230': 0x1f567,
    \ 'clock130': 0x1f55c,
    \ 'clock2': 0x1f551,
    \ 'clock230': 0x1f55d,
    \ 'clock3': 0x1f552,
    \ 'clock330': 0x1f55e,
    \ 'clock4': 0x1f553,
    \ 'clock430': 0x1f55f,
    \ 'clock5': 0x1f554,
    \ 'clock530': 0x1f560,
    \ 'clock6': 0x1f555,
    \ 'clock630': 0x1f561,
    \ 'clock7': 0x1f556,
    \ 'clock730': 0x1f562,
    \ 'clock8': 0x1f557,
    \ 'clock830': 0x1f563,
    \ 'clock9': 0x1f558,
    \ 'clock930': 0x1f564,
    \ 'closed_book': 0x1f4d5,
    \ 'closed_lock_with_key': 0x1f510,
    \ 'closed_umbrella': 0x1f302,
    \ 'cloud': 0x2601,
    \ 'clown_face': 0x1f921,
    \ 'clubs': 0x2663,
    \ 'cn': [0x1f1e8, 0x1f1f3],
    \ 'coat': 0x1f9e5,
    \ 'cocktail': 0x1f378,
    \ 'coconut': 0x1f965,
    \ 'coffee': 0x2615,
    \ 'coffin': 0x26b0,
    \ 'cold_sweat': 0x1f630,
    \ 'collision': 0x1f4a5,
    \ 'comet': 0x2604,
    \ 'compression': 0x1f5dc,
    \ 'computer': 0x1f4bb,
    \ 'confetti_ball': 0x1f38a,
    \ 'confounded': 0x1f616,
    \ 'confused': 0x1f615,
    \ 'congratulations': 0x3297,
    \ 'construction': 0x1f6a7,
    \ 'construction_worker': 0x1f477,
    \ 'control_knobs': 0x1f39b,
    \ 'convenience_store': 0x1f3ea,
    \ 'cookie': 0x1f36a,
    \ 'cool': 0x1f192,
    \ 'cop': 0x1f46e,
    \ 'copyright': 0x00a9,
    \ 'corn': 0x1f33d,
    \ 'couch_and_lamp': 0x1f6cb,
    \ 'couple': 0x1f46b,
    \ 'couple_with_heart': 0x1f491,
    \ 'couplekiss': 0x1f48f,
    \ 'cow': 0x1f42e,
    \ 'cow2': 0x1f404,
    \ 'crab': 0x1f980,
    \ 'credit_card': 0x1f4b3,
    \ 'crescent_moon': 0x1f319,
    \ 'cricket': 0x1f997,
    \ 'cricket_bat_and_ball': 0x1f3cf,
    \ 'crocodile': 0x1f40a,
    \ 'croissant': 0x1f950,
    \ 'crossed_flags': 0x1f38c,
    \ 'crossed_swords': 0x2694,
    \ 'crown': 0x1f451,
    \ 'cry': 0x1f622,
    \ 'crying_cat_face': 0x1f63f,
    \ 'crystal_ball': 0x1f52e,
    \ 'cucumber': 0x1f952,
    \ 'cup_with_straw': 0x1f964,
    \ 'cupid': 0x1f498,
    \ 'curling_stone': 0x1f94c,
    \ 'curly_loop': 0x27b0,
    \ 'currency_exchange': 0x1f4b1,
    \ 'curry': 0x1f35b,
    \ 'custard': 0x1f36e,
    \ 'customs': 0x1f6c3,
    \ 'cut_of_meat': 0x1f969,
    \ 'cyclone': 0x1f300,
    \ 'dagger_knife': 0x1f5e1,
    \ 'dancer': 0x1f483,
    \ 'dancers': 0x1f46f,
    \ 'dango': 0x1f361,
    \ 'dark_sunglasses': 0x1f576,
    \ 'dart': 0x1f3af,
    \ 'dash': 0x1f4a8,
    \ 'date': 0x1f4c5,
    \ 'de': [0x1f1e9, 0x1f1ea],
    \ 'deciduous_tree': 0x1f333,
    \ 'deer': 0x1f98c,
    \ 'department_store': 0x1f3ec,
    \ 'derelict_house_building': 0x1f3da,
    \ 'desert': 0x1f3dc,
    \ 'desert_island': 0x1f3dd,
    \ 'desktop_computer': 0x1f5a5,
    \ 'diamond_shape_with_a_dot_inside': 0x1f4a0,
    \ 'diamonds': 0x2666,
    \ 'disappointed': 0x1f61e,
    \ 'disappointed_relieved': 0x1f625,
    \ 'dizzy': 0x1f4ab,
    \ 'dizzy_face': 0x1f635,
    \ 'do_not_litter': 0x1f6af,
    \ 'dog': 0x1f436,
    \ 'dog2': 0x1f415,
    \ 'dollar': 0x1f4b5,
    \ 'dolls': 0x1f38e,
    \ 'dolphin': 0x1f42c,
    \ 'door': 0x1f6aa,
    \ 'double_vertical_bar': 0x23f8,
    \ 'doughnut': 0x1f369,
    \ 'dove_of_peace': 0x1f54a,
    \ 'dragon': 0x1f409,
    \ 'dragon_face': 0x1f432,
    \ 'dress': 0x1f457,
    \ 'dromedary_camel': 0x1f42a,
    \ 'drooling_face': 0x1f924,
    \ 'droplet': 0x1f4a7,
    \ 'drum_with_drumsticks': 0x1f941,
    \ 'duck': 0x1f986,
    \ 'dumpling': 0x1f95f,
    \ 'dvd': 0x1f4c0,
    \ 'e-mail': 0x1f4e7,
    \ 'eagle': 0x1f985,
    \ 'ear': 0x1f442,
    \ 'ear_of_rice': 0x1f33e,
    \ 'earth_africa': 0x1f30d,
    \ 'earth_americas': 0x1f30e,
    \ 'earth_asia': 0x1f30f,
    \ 'egg': 0x1f373,
    \ 'eggplant': 0x1f346,
    \ 'eight': 0x0038,
    \ 'eight_pointed_black_star': 0x2734,
    \ 'eight_spoked_asterisk': 0x2733,
    \ 'eject': 0x23cf,
    \ 'electric_plug': 0x1f50c,
    \ 'elephant': 0x1f418,
    \ 'elf': 0x1f9dd,
    \ 'email': 0x2709,
    \ 'end': 0x1f51a,
    \ 'envelope': 0x2709,
    \ 'envelope_with_arrow': 0x1f4e9,
    \ 'es': [0x1f1ea, 0x1f1f8],
    \ 'euro': 0x1f4b6,
    \ 'european_castle': 0x1f3f0,
    \ 'european_post_office': 0x1f3e4,
    \ 'evergreen_tree': 0x1f332,
    \ 'exclamation': 0x2757,
    \ 'expressionless': 0x1f611,
    \ 'eye': 0x1f441,
    \ 'eye-in-speech-bubble': [0x1f441, 0xfe0f, 0x200d, 0x1f5e8],
    \ 'eyeglasses': 0x1f453,
    \ 'eyes': 0x1f440,
    \ 'face_palm': 0x1f926,
    \ 'face_with_cowboy_hat': 0x1f920,
    \ 'face_with_finger_covering_closed_lips': 0x1f92b,
    \ 'face_with_head_bandage': 0x1f915,
    \ 'face_with_monocle': 0x1f9d0,
    \ 'face_with_one_eyebrow_raised': 0x1f928,
    \ 'face_with_open_mouth_vomiting': 0x1f92e,
    \ 'face_with_rolling_eyes': 0x1f644,
    \ 'face_with_thermometer': 0x1f912,
    \ 'facepunch': 0x1f44a,
    \ 'factory': 0x1f3ed,
    \ 'fairy': 0x1f9da,
    \ 'fallen_leaf': 0x1f342,
    \ 'family': 0x1f46a,
    \ 'fast_forward': 0x23e9,
    \ 'fax': 0x1f4e0,
    \ 'fearful': 0x1f628,
    \ 'feet': 0x1f43e,
    \ 'female-artist': [0x1f469, 0x200d, 0x1f3a8],
    \ 'female-astronaut': [0x1f469, 0x200d, 0x1f680],
    \ 'female-construction-worker': [0x1f477, 0x200d, 0x2640],
    \ 'female-cook': [0x1f469, 0x200d, 0x1f373],
    \ 'female-detective': [0x1f575, 0xfe0f, 0x200d, 0x2640],
    \ 'female-doctor': [0x1f469, 0x200d, 0x2695],
    \ 'female-factory-worker': [0x1f469, 0x200d, 0x1f3ed],
    \ 'female-farmer': [0x1f469, 0x200d, 0x1f33e],
    \ 'female-firefighter': [0x1f469, 0x200d, 0x1f692],
    \ 'female-guard': [0x1f482, 0x200d, 0x2640],
    \ 'female-judge': [0x1f469, 0x200d, 0x2696],
    \ 'female-mechanic': [0x1f469, 0x200d, 0x1f527],
    \ 'female-office-worker': [0x1f469, 0x200d, 0x1f4bc],
    \ 'female-pilot': [0x1f469, 0x200d, 0x2708],
    \ 'female-police-officer': [0x1f46e, 0x200d, 0x2640],
    \ 'female-scientist': [0x1f469, 0x200d, 0x1f52c],
    \ 'female-singer': [0x1f469, 0x200d, 0x1f3a4],
    \ 'female-student': [0x1f469, 0x200d, 0x1f393],
    \ 'female-teacher': [0x1f469, 0x200d, 0x1f3eb],
    \ 'female-technologist': [0x1f469, 0x200d, 0x1f4bb],
    \ 'female_elf': [0x1f9dd, 0x200d, 0x2640],
    \ 'female_fairy': [0x1f9da, 0x200d, 0x2640],
    \ 'female_genie': [0x1f9de, 0x200d, 0x2640],
    \ 'female_mage': [0x1f9d9, 0x200d, 0x2640],
    \ 'female_sign': 0x2640,
    \ 'female_vampire': [0x1f9db, 0x200d, 0x2640],
    \ 'female_zombie': [0x1f9df, 0x200d, 0x2640],
    \ 'fencer': 0x1f93a,
    \ 'ferris_wheel': 0x1f3a1,
    \ 'ferry': 0x26f4,
    \ 'field_hockey_stick_and_ball': 0x1f3d1,
    \ 'file_cabinet': 0x1f5c4,
    \ 'file_folder': 0x1f4c1,
    \ 'film_frames': 0x1f39e,
    \ 'film_projector': 0x1f4fd,
    \ 'fire': 0x1f525,
    \ 'fire_engine': 0x1f692,
    \ 'fireworks': 0x1f386,
    \ 'first_place_medal': 0x1f947,
    \ 'first_quarter_moon': 0x1f313,
    \ 'first_quarter_moon_with_face': 0x1f31b,
    \ 'fish': 0x1f41f,
    \ 'fish_cake': 0x1f365,
    \ 'fishing_pole_and_fish': 0x1f3a3,
    \ 'fist': 0x270a,
    \ 'five': 0x0035,
    \ 'flag-ac': [0x1f1e6, 0x1f1e8],
    \ 'flag-ad': [0x1f1e6, 0x1f1e9],
    \ 'flag-ae': [0x1f1e6, 0x1f1ea],
    \ 'flag-af': [0x1f1e6, 0x1f1eb],
    \ 'flag-ag': [0x1f1e6, 0x1f1ec],
    \ 'flag-ai': [0x1f1e6, 0x1f1ee],
    \ 'flag-al': [0x1f1e6, 0x1f1f1],
    \ 'flag-am': [0x1f1e6, 0x1f1f2],
    \ 'flag-ao': [0x1f1e6, 0x1f1f4],
    \ 'flag-aq': [0x1f1e6, 0x1f1f6],
    \ 'flag-ar': [0x1f1e6, 0x1f1f7],
    \ 'flag-as': [0x1f1e6, 0x1f1f8],
    \ 'flag-at': [0x1f1e6, 0x1f1f9],
    \ 'flag-au': [0x1f1e6, 0x1f1fa],
    \ 'flag-aw': [0x1f1e6, 0x1f1fc],
    \ 'flag-ax': [0x1f1e6, 0x1f1fd],
    \ 'flag-az': [0x1f1e6, 0x1f1ff],
    \ 'flag-ba': [0x1f1e7, 0x1f1e6],
    \ 'flag-bb': [0x1f1e7, 0x1f1e7],
    \ 'flag-bd': [0x1f1e7, 0x1f1e9],
    \ 'flag-be': [0x1f1e7, 0x1f1ea],
    \ 'flag-bf': [0x1f1e7, 0x1f1eb],
    \ 'flag-bg': [0x1f1e7, 0x1f1ec],
    \ 'flag-bh': [0x1f1e7, 0x1f1ed],
    \ 'flag-bi': [0x1f1e7, 0x1f1ee],
    \ 'flag-bj': [0x1f1e7, 0x1f1ef],
    \ 'flag-bl': [0x1f1e7, 0x1f1f1],
    \ 'flag-bm': [0x1f1e7, 0x1f1f2],
    \ 'flag-bn': [0x1f1e7, 0x1f1f3],
    \ 'flag-bo': [0x1f1e7, 0x1f1f4],
    \ 'flag-bq': [0x1f1e7, 0x1f1f6],
    \ 'flag-br': [0x1f1e7, 0x1f1f7],
    \ 'flag-bs': [0x1f1e7, 0x1f1f8],
    \ 'flag-bt': [0x1f1e7, 0x1f1f9],
    \ 'flag-bv': [0x1f1e7, 0x1f1fb],
    \ 'flag-bw': [0x1f1e7, 0x1f1fc],
    \ 'flag-by': [0x1f1e7, 0x1f1fe],
    \ 'flag-bz': [0x1f1e7, 0x1f1ff],
    \ 'flag-ca': [0x1f1e8, 0x1f1e6],
    \ 'flag-cc': [0x1f1e8, 0x1f1e8],
    \ 'flag-cd': [0x1f1e8, 0x1f1e9],
    \ 'flag-cf': [0x1f1e8, 0x1f1eb],
    \ 'flag-cg': [0x1f1e8, 0x1f1ec],
    \ 'flag-ch': [0x1f1e8, 0x1f1ed],
    \ 'flag-ci': [0x1f1e8, 0x1f1ee],
    \ 'flag-ck': [0x1f1e8, 0x1f1f0],
    \ 'flag-cl': [0x1f1e8, 0x1f1f1],
    \ 'flag-cm': [0x1f1e8, 0x1f1f2],
    \ 'flag-co': [0x1f1e8, 0x1f1f4],
    \ 'flag-cp': [0x1f1e8, 0x1f1f5],
    \ 'flag-cr': [0x1f1e8, 0x1f1f7],
    \ 'flag-cu': [0x1f1e8, 0x1f1fa],
    \ 'flag-cv': [0x1f1e8, 0x1f1fb],
    \ 'flag-cw': [0x1f1e8, 0x1f1fc],
    \ 'flag-cx': [0x1f1e8, 0x1f1fd],
    \ 'flag-cy': [0x1f1e8, 0x1f1fe],
    \ 'flag-cz': [0x1f1e8, 0x1f1ff],
    \ 'flag-dg': [0x1f1e9, 0x1f1ec],
    \ 'flag-dj': [0x1f1e9, 0x1f1ef],
    \ 'flag-dk': [0x1f1e9, 0x1f1f0],
    \ 'flag-dm': [0x1f1e9, 0x1f1f2],
    \ 'flag-do': [0x1f1e9, 0x1f1f4],
    \ 'flag-dz': [0x1f1e9, 0x1f1ff],
    \ 'flag-ea': [0x1f1ea, 0x1f1e6],
    \ 'flag-ec': [0x1f1ea, 0x1f1e8],
    \ 'flag-ee': [0x1f1ea, 0x1f1ea],
    \ 'flag-eg': [0x1f1ea, 0x1f1ec],
    \ 'flag-eh': [0x1f1ea, 0x1f1ed],
    \ 'flag-england': [0x1f3f4, 0xe0067, 0xe0062, 0xe0065, 0xe006e, 0xe0067, 0xe007f],
    \ 'flag-er': [0x1f1ea, 0x1f1f7],
    \ 'flag-et': [0x1f1ea, 0x1f1f9],
    \ 'flag-eu': [0x1f1ea, 0x1f1fa],
    \ 'flag-fi': [0x1f1eb, 0x1f1ee],
    \ 'flag-fj': [0x1f1eb, 0x1f1ef],
    \ 'flag-fk': [0x1f1eb, 0x1f1f0],
    \ 'flag-fm': [0x1f1eb, 0x1f1f2],
    \ 'flag-fo': [0x1f1eb, 0x1f1f4],
    \ 'flag-ga': [0x1f1ec, 0x1f1e6],
    \ 'flag-gd': [0x1f1ec, 0x1f1e9],
    \ 'flag-ge': [0x1f1ec, 0x1f1ea],
    \ 'flag-gf': [0x1f1ec, 0x1f1eb],
    \ 'flag-gg': [0x1f1ec, 0x1f1ec],
    \ 'flag-gh': [0x1f1ec, 0x1f1ed],
    \ 'flag-gi': [0x1f1ec, 0x1f1ee],
    \ 'flag-gl': [0x1f1ec, 0x1f1f1],
    \ 'flag-gm': [0x1f1ec, 0x1f1f2],
    \ 'flag-gn': [0x1f1ec, 0x1f1f3],
    \ 'flag-gp': [0x1f1ec, 0x1f1f5],
    \ 'flag-gq': [0x1f1ec, 0x1f1f6],
    \ 'flag-gr': [0x1f1ec, 0x1f1f7],
    \ 'flag-gs': [0x1f1ec, 0x1f1f8],
    \ 'flag-gt': [0x1f1ec, 0x1f1f9],
    \ 'flag-gu': [0x1f1ec, 0x1f1fa],
    \ 'flag-gw': [0x1f1ec, 0x1f1fc],
    \ 'flag-gy': [0x1f1ec, 0x1f1fe],
    \ 'flag-hk': [0x1f1ed, 0x1f1f0],
    \ 'flag-hm': [0x1f1ed, 0x1f1f2],
    \ 'flag-hn': [0x1f1ed, 0x1f1f3],
    \ 'flag-hr': [0x1f1ed, 0x1f1f7],
    \ 'flag-ht': [0x1f1ed, 0x1f1f9],
    \ 'flag-hu': [0x1f1ed, 0x1f1fa],
    \ 'flag-ic': [0x1f1ee, 0x1f1e8],
    \ 'flag-id': [0x1f1ee, 0x1f1e9],
    \ 'flag-ie': [0x1f1ee, 0x1f1ea],
    \ 'flag-il': [0x1f1ee, 0x1f1f1],
    \ 'flag-im': [0x1f1ee, 0x1f1f2],
    \ 'flag-in': [0x1f1ee, 0x1f1f3],
    \ 'flag-io': [0x1f1ee, 0x1f1f4],
    \ 'flag-iq': [0x1f1ee, 0x1f1f6],
    \ 'flag-ir': [0x1f1ee, 0x1f1f7],
    \ 'flag-is': [0x1f1ee, 0x1f1f8],
    \ 'flag-je': [0x1f1ef, 0x1f1ea],
    \ 'flag-jm': [0x1f1ef, 0x1f1f2],
    \ 'flag-jo': [0x1f1ef, 0x1f1f4],
    \ 'flag-ke': [0x1f1f0, 0x1f1ea],
    \ 'flag-kg': [0x1f1f0, 0x1f1ec],
    \ 'flag-kh': [0x1f1f0, 0x1f1ed],
    \ 'flag-ki': [0x1f1f0, 0x1f1ee],
    \ 'flag-km': [0x1f1f0, 0x1f1f2],
    \ 'flag-kn': [0x1f1f0, 0x1f1f3],
    \ 'flag-kp': [0x1f1f0, 0x1f1f5],
    \ 'flag-kw': [0x1f1f0, 0x1f1fc],
    \ 'flag-ky': [0x1f1f0, 0x1f1fe],
    \ 'flag-kz': [0x1f1f0, 0x1f1ff],
    \ 'flag-la': [0x1f1f1, 0x1f1e6],
    \ 'flag-lb': [0x1f1f1, 0x1f1e7],
    \ 'flag-lc': [0x1f1f1, 0x1f1e8],
    \ 'flag-li': [0x1f1f1, 0x1f1ee],
    \ 'flag-lk': [0x1f1f1, 0x1f1f0],
    \ 'flag-lr': [0x1f1f1, 0x1f1f7],
    \ 'flag-ls': [0x1f1f1, 0x1f1f8],
    \ 'flag-lt': [0x1f1f1, 0x1f1f9],
    \ 'flag-lu': [0x1f1f1, 0x1f1fa],
    \ 'flag-lv': [0x1f1f1, 0x1f1fb],
    \ 'flag-ly': [0x1f1f1, 0x1f1fe],
    \ 'flag-ma': [0x1f1f2, 0x1f1e6],
    \ 'flag-mc': [0x1f1f2, 0x1f1e8],
    \ 'flag-md': [0x1f1f2, 0x1f1e9],
    \ 'flag-me': [0x1f1f2, 0x1f1ea],
    \ 'flag-mf': [0x1f1f2, 0x1f1eb],
    \ 'flag-mg': [0x1f1f2, 0x1f1ec],
    \ 'flag-mh': [0x1f1f2, 0x1f1ed],
    \ 'flag-mk': [0x1f1f2, 0x1f1f0],
    \ 'flag-ml': [0x1f1f2, 0x1f1f1],
    \ 'flag-mm': [0x1f1f2, 0x1f1f2],
    \ 'flag-mn': [0x1f1f2, 0x1f1f3],
    \ 'flag-mo': [0x1f1f2, 0x1f1f4],
    \ 'flag-mp': [0x1f1f2, 0x1f1f5],
    \ 'flag-mq': [0x1f1f2, 0x1f1f6],
    \ 'flag-mr': [0x1f1f2, 0x1f1f7],
    \ 'flag-ms': [0x1f1f2, 0x1f1f8],
    \ 'flag-mt': [0x1f1f2, 0x1f1f9],
    \ 'flag-mu': [0x1f1f2, 0x1f1fa],
    \ 'flag-mv': [0x1f1f2, 0x1f1fb],
    \ 'flag-mw': [0x1f1f2, 0x1f1fc],
    \ 'flag-mx': [0x1f1f2, 0x1f1fd],
    \ 'flag-my': [0x1f1f2, 0x1f1fe],
    \ 'flag-mz': [0x1f1f2, 0x1f1ff],
    \ 'flag-na': [0x1f1f3, 0x1f1e6],
    \ 'flag-nc': [0x1f1f3, 0x1f1e8],
    \ 'flag-ne': [0x1f1f3, 0x1f1ea],
    \ 'flag-nf': [0x1f1f3, 0x1f1eb],
    \ 'flag-ng': [0x1f1f3, 0x1f1ec],
    \ 'flag-ni': [0x1f1f3, 0x1f1ee],
    \ 'flag-nl': [0x1f1f3, 0x1f1f1],
    \ 'flag-no': [0x1f1f3, 0x1f1f4],
    \ 'flag-np': [0x1f1f3, 0x1f1f5],
    \ 'flag-nr': [0x1f1f3, 0x1f1f7],
    \ 'flag-nu': [0x1f1f3, 0x1f1fa],
    \ 'flag-nz': [0x1f1f3, 0x1f1ff],
    \ 'flag-om': [0x1f1f4, 0x1f1f2],
    \ 'flag-pa': [0x1f1f5, 0x1f1e6],
    \ 'flag-pe': [0x1f1f5, 0x1f1ea],
    \ 'flag-pf': [0x1f1f5, 0x1f1eb],
    \ 'flag-pg': [0x1f1f5, 0x1f1ec],
    \ 'flag-ph': [0x1f1f5, 0x1f1ed],
    \ 'flag-pk': [0x1f1f5, 0x1f1f0],
    \ 'flag-pl': [0x1f1f5, 0x1f1f1],
    \ 'flag-pm': [0x1f1f5, 0x1f1f2],
    \ 'flag-pn': [0x1f1f5, 0x1f1f3],
    \ 'flag-pr': [0x1f1f5, 0x1f1f7],
    \ 'flag-ps': [0x1f1f5, 0x1f1f8],
    \ 'flag-pt': [0x1f1f5, 0x1f1f9],
    \ 'flag-pw': [0x1f1f5, 0x1f1fc],
    \ 'flag-py': [0x1f1f5, 0x1f1fe],
    \ 'flag-qa': [0x1f1f6, 0x1f1e6],
    \ 'flag-re': [0x1f1f7, 0x1f1ea],
    \ 'flag-ro': [0x1f1f7, 0x1f1f4],
    \ 'flag-rs': [0x1f1f7, 0x1f1f8],
    \ 'flag-rw': [0x1f1f7, 0x1f1fc],
    \ 'flag-sa': [0x1f1f8, 0x1f1e6],
    \ 'flag-sb': [0x1f1f8, 0x1f1e7],
    \ 'flag-sc': [0x1f1f8, 0x1f1e8],
    \ 'flag-scotland': [0x1f3f4, 0xe0067, 0xe0062, 0xe0073, 0xe0063, 0xe0074, 0xe007f],
    \ 'flag-sd': [0x1f1f8, 0x1f1e9],
    \ 'flag-se': [0x1f1f8, 0x1f1ea],
    \ 'flag-sg': [0x1f1f8, 0x1f1ec],
    \ 'flag-sh': [0x1f1f8, 0x1f1ed],
    \ 'flag-si': [0x1f1f8, 0x1f1ee],
    \ 'flag-sj': [0x1f1f8, 0x1f1ef],
    \ 'flag-sk': [0x1f1f8, 0x1f1f0],
    \ 'flag-sl': [0x1f1f8, 0x1f1f1],
    \ 'flag-sm': [0x1f1f8, 0x1f1f2],
    \ 'flag-sn': [0x1f1f8, 0x1f1f3],
    \ 'flag-so': [0x1f1f8, 0x1f1f4],
    \ 'flag-sr': [0x1f1f8, 0x1f1f7],
    \ 'flag-ss': [0x1f1f8, 0x1f1f8],
    \ 'flag-st': [0x1f1f8, 0x1f1f9],
    \ 'flag-sv': [0x1f1f8, 0x1f1fb],
    \ 'flag-sx': [0x1f1f8, 0x1f1fd],
    \ 'flag-sy': [0x1f1f8, 0x1f1fe],
    \ 'flag-sz': [0x1f1f8, 0x1f1ff],
    \ 'flag-ta': [0x1f1f9, 0x1f1e6],
    \ 'flag-tc': [0x1f1f9, 0x1f1e8],
    \ 'flag-td': [0x1f1f9, 0x1f1e9],
    \ 'flag-tf': [0x1f1f9, 0x1f1eb],
    \ 'flag-tg': [0x1f1f9, 0x1f1ec],
    \ 'flag-th': [0x1f1f9, 0x1f1ed],
    \ 'flag-tj': [0x1f1f9, 0x1f1ef],
    \ 'flag-tk': [0x1f1f9, 0x1f1f0],
    \ 'flag-tl': [0x1f1f9, 0x1f1f1],
    \ 'flag-tm': [0x1f1f9, 0x1f1f2],
    \ 'flag-tn': [0x1f1f9, 0x1f1f3],
    \ 'flag-to': [0x1f1f9, 0x1f1f4],
    \ 'flag-tr': [0x1f1f9, 0x1f1f7],
    \ 'flag-tt': [0x1f1f9, 0x1f1f9],
    \ 'flag-tv': [0x1f1f9, 0x1f1fb],
    \ 'flag-tw': [0x1f1f9, 0x1f1fc],
    \ 'flag-tz': [0x1f1f9, 0x1f1ff],
    \ 'flag-ua': [0x1f1fa, 0x1f1e6],
    \ 'flag-ug': [0x1f1fa, 0x1f1ec],
    \ 'flag-um': [0x1f1fa, 0x1f1f2],
    \ 'flag-un': [0x1f1fa, 0x1f1f3],
    \ 'flag-uy': [0x1f1fa, 0x1f1fe],
    \ 'flag-uz': [0x1f1fa, 0x1f1ff],
    \ 'flag-va': [0x1f1fb, 0x1f1e6],
    \ 'flag-vc': [0x1f1fb, 0x1f1e8],
    \ 'flag-ve': [0x1f1fb, 0x1f1ea],
    \ 'flag-vg': [0x1f1fb, 0x1f1ec],
    \ 'flag-vi': [0x1f1fb, 0x1f1ee],
    \ 'flag-vn': [0x1f1fb, 0x1f1f3],
    \ 'flag-vu': [0x1f1fb, 0x1f1fa],
    \ 'flag-wales': [0x1f3f4, 0xe0067, 0xe0062, 0xe0077, 0xe006c, 0xe0073, 0xe007f],
    \ 'flag-wf': [0x1f1fc, 0x1f1eb],
    \ 'flag-ws': [0x1f1fc, 0x1f1f8],
    \ 'flag-xk': [0x1f1fd, 0x1f1f0],
    \ 'flag-ye': [0x1f1fe, 0x1f1ea],
    \ 'flag-yt': [0x1f1fe, 0x1f1f9],
    \ 'flag-za': [0x1f1ff, 0x1f1e6],
    \ 'flag-zm': [0x1f1ff, 0x1f1f2],
    \ 'flag-zw': [0x1f1ff, 0x1f1fc],
    \ 'flags': 0x1f38f,
    \ 'flashlight': 0x1f526,
    \ 'fleur_de_lis': 0x269c,
    \ 'flipper': 0x1f42c,
    \ 'floppy_disk': 0x1f4be,
    \ 'flower_playing_cards': 0x1f3b4,
    \ 'flushed': 0x1f633,
    \ 'flying_saucer': 0x1f6f8,
    \ 'fog': 0x1f32b,
    \ 'foggy': 0x1f301,
    \ 'football': 0x1f3c8,
    \ 'footprints': 0x1f463,
    \ 'fork_and_knife': 0x1f374,
    \ 'fortune_cookie': 0x1f960,
    \ 'fountain': 0x26f2,
    \ 'four': 0x0034,
    \ 'four_leaf_clover': 0x1f340,
    \ 'fox_face': 0x1f98a,
    \ 'fr': [0x1f1eb, 0x1f1f7],
    \ 'frame_with_picture': 0x1f5bc,
    \ 'free': 0x1f193,
    \ 'fried_egg': 0x1f373,
    \ 'fried_shrimp': 0x1f364,
    \ 'fries': 0x1f35f,
    \ 'frog': 0x1f438,
    \ 'frowning': 0x1f626,
    \ 'fuelpump': 0x26fd,
    \ 'full_moon': 0x1f315,
    \ 'full_moon_with_face': 0x1f31d,
    \ 'funeral_urn': 0x26b1,
    \ 'game_die': 0x1f3b2,
    \ 'gb': [0x1f1ec, 0x1f1e7],
    \ 'gear': 0x2699,
    \ 'gem': 0x1f48e,
    \ 'gemini': 0x264a,
    \ 'genie': 0x1f9de,
    \ 'ghost': 0x1f47b,
    \ 'gift': 0x1f381,
    \ 'gift_heart': 0x1f49d,
    \ 'giraffe_face': 0x1f992,
    \ 'girl': 0x1f467,
    \ 'glass_of_milk': 0x1f95b,
    \ 'globe_with_meridians': 0x1f310,
    \ 'gloves': 0x1f9e4,
    \ 'goal_net': 0x1f945,
    \ 'goat': 0x1f410,
    \ 'golf': 0x26f3,
    \ 'golfer': 0x1f3cc,
    \ 'gorilla': 0x1f98d,
    \ 'grapes': 0x1f347,
    \ 'green_apple': 0x1f34f,
    \ 'green_book': 0x1f4d7,
    \ 'green_heart': 0x1f49a,
    \ 'green_salad': 0x1f957,
    \ 'grey_exclamation': 0x2755,
    \ 'grey_question': 0x2754,
    \ 'grimacing': 0x1f62c,
    \ 'grin': 0x1f601,
    \ 'grinning': 0x1f600,
    \ 'grinning_face_with_one_large_and_one_small_eye': 0x1f92a,
    \ 'grinning_face_with_star_eyes': 0x1f929,
    \ 'guardsman': 0x1f482,
    \ 'guitar': 0x1f3b8,
    \ 'gun': 0x1f52b,
    \ 'haircut': 0x1f487,
    \ 'hamburger': 0x1f354,
    \ 'hammer': 0x1f528,
    \ 'hammer_and_pick': 0x2692,
    \ 'hammer_and_wrench': 0x1f6e0,
    \ 'hamster': 0x1f439,
    \ 'hand': 0x270b,
    \ 'hand_with_index_and_middle_fingers_crossed': 0x1f91e,
    \ 'handbag': 0x1f45c,
    \ 'handball': 0x1f93e,
    \ 'handshake': 0x1f91d,
    \ 'hankey': 0x1f4a9,
    \ 'hash': 0x0023,
    \ 'hatched_chick': 0x1f425,
    \ 'hatching_chick': 0x1f423,
    \ 'headphones': 0x1f3a7,
    \ 'hear_no_evil': 0x1f649,
    \ 'heart': 0x2764,
    \ 'heart_decoration': 0x1f49f,
    \ 'heart_eyes': 0x1f60d,
    \ 'heart_eyes_cat': 0x1f63b,
    \ 'heartbeat': 0x1f493,
    \ 'heartpulse': 0x1f497,
    \ 'hearts': 0x2665,
    \ 'heavy_check_mark': 0x2714,
    \ 'heavy_division_sign': 0x2797,
    \ 'heavy_dollar_sign': 0x1f4b2,
    \ 'heavy_exclamation_mark': 0x2757,
    \ 'heavy_heart_exclamation_mark_ornament': 0x2763,
    \ 'heavy_minus_sign': 0x2796,
    \ 'heavy_multiplication_x': 0x2716,
    \ 'heavy_plus_sign': 0x2795,
    \ 'hedgehog': 0x1f994,
    \ 'helicopter': 0x1f681,
    \ 'helmet_with_white_cross': 0x26d1,
    \ 'herb': 0x1f33f,
    \ 'hibiscus': 0x1f33a,
    \ 'high_brightness': 0x1f506,
    \ 'high_heel': 0x1f460,
    \ 'hocho': 0x1f52a,
    \ 'hole': 0x1f573,
    \ 'honey_pot': 0x1f36f,
    \ 'honeybee': 0x1f41d,
    \ 'horse': 0x1f434,
    \ 'horse_racing': 0x1f3c7,
    \ 'hospital': 0x1f3e5,
    \ 'hot_pepper': 0x1f336,
    \ 'hotdog': 0x1f32d,
    \ 'hotel': 0x1f3e8,
    \ 'hotsprings': 0x2668,
    \ 'hourglass': 0x231b,
    \ 'hourglass_flowing_sand': 0x23f3,
    \ 'house': 0x1f3e0,
    \ 'house_buildings': 0x1f3d8,
    \ 'house_with_garden': 0x1f3e1,
    \ 'hugging_face': 0x1f917,
    \ 'hushed': 0x1f62f,
    \ 'i_love_you_hand_sign': 0x1f91f,
    \ 'ice_cream': 0x1f368,
    \ 'ice_hockey_stick_and_puck': 0x1f3d2,
    \ 'ice_skate': 0x26f8,
    \ 'icecream': 0x1f366,
    \ 'id': 0x1f194,
    \ 'ideograph_advantage': 0x1f250,
    \ 'imp': 0x1f47f,
    \ 'inbox_tray': 0x1f4e5,
    \ 'incoming_envelope': 0x1f4e8,
    \ 'information_desk_person': 0x1f481,
    \ 'information_source': 0x2139,
    \ 'innocent': 0x1f607,
    \ 'interrobang': 0x2049,
    \ 'iphone': 0x1f4f1,
    \ 'it': [0x1f1ee, 0x1f1f9],
    \ 'izakaya_lantern': 0x1f3ee,
    \ 'jack_o_lantern': 0x1f383,
    \ 'japan': 0x1f5fe,
    \ 'japanese_castle': 0x1f3ef,
    \ 'japanese_goblin': 0x1f47a,
    \ 'japanese_ogre': 0x1f479,
    \ 'jeans': 0x1f456,
    \ 'joy': 0x1f602,
    \ 'joy_cat': 0x1f639,
    \ 'joystick': 0x1f579,
    \ 'jp': [0x1f1ef, 0x1f1f5],
    \ 'juggling': 0x1f939,
    \ 'kaaba': 0x1f54b,
    \ 'key': 0x1f511,
    \ 'keyboard': 0x2328,
    \ 'keycap_star': [0x002a, 0xfe0f, 0x20e3],
    \ 'keycap_ten': 0x1f51f,
    \ 'kimono': 0x1f458,
    \ 'kiss': 0x1f48b,
    \ 'kissing': 0x1f617,
    \ 'kissing_cat': 0x1f63d,
    \ 'kissing_closed_eyes': 0x1f61a,
    \ 'kissing_heart': 0x1f618,
    \ 'kissing_smiling_eyes': 0x1f619,
    \ 'kiwifruit': 0x1f95d,
    \ 'knife_fork_plate': 0x1f37d,
    \ 'koala': 0x1f428,
    \ 'koko': 0x1f201,
    \ 'kr': [0x1f1f0, 0x1f1f7],
    \ 'label': 0x1f3f7,
    \ 'lantern': 0x1f3ee,
    \ 'large_blue_circle': 0x1f535,
    \ 'large_blue_diamond': 0x1f537,
    \ 'large_orange_diamond': 0x1f536,
    \ 'last_quarter_moon': 0x1f317,
    \ 'last_quarter_moon_with_face': 0x1f31c,
    \ 'latin_cross': 0x271d,
    \ 'laughing': 0x1f606,
    \ 'leaves': 0x1f343,
    \ 'ledger': 0x1f4d2,
    \ 'left-facing_fist': 0x1f91b,
    \ 'left_luggage': 0x1f6c5,
    \ 'left_right_arrow': 0x2194,
    \ 'left_speech_bubble': 0x1f5e8,
    \ 'leftwards_arrow_with_hook': 0x21a9,
    \ 'lemon': 0x1f34b,
    \ 'leo': 0x264c,
    \ 'leopard': 0x1f406,
    \ 'level_slider': 0x1f39a,
    \ 'libra': 0x264e,
    \ 'light_rail': 0x1f688,
    \ 'lightning': 0x1f329,
    \ 'link': 0x1f517,
    \ 'linked_paperclips': 0x1f587,
    \ 'lion_face': 0x1f981,
    \ 'lips': 0x1f444,
    \ 'lipstick': 0x1f484,
    \ 'lizard': 0x1f98e,
    \ 'lock': 0x1f512,
    \ 'lock_with_ink_pen': 0x1f50f,
    \ 'lollipop': 0x1f36d,
    \ 'loop': 0x27bf,
    \ 'loud_sound': 0x1f50a,
    \ 'loudspeaker': 0x1f4e2,
    \ 'love_hotel': 0x1f3e9,
    \ 'love_letter': 0x1f48c,
    \ 'low_brightness': 0x1f505,
    \ 'lower_left_ballpoint_pen': 0x1f58a,
    \ 'lower_left_crayon': 0x1f58d,
    \ 'lower_left_fountain_pen': 0x1f58b,
    \ 'lower_left_paintbrush': 0x1f58c,
    \ 'lying_face': 0x1f925,
    \ 'm': 0x24c2,
    \ 'mag': 0x1f50d,
    \ 'mag_right': 0x1f50e,
    \ 'mage': 0x1f9d9,
    \ 'mahjong': 0x1f004,
    \ 'mailbox': 0x1f4eb,
    \ 'mailbox_closed': 0x1f4ea,
    \ 'mailbox_with_mail': 0x1f4ec,
    \ 'mailbox_with_no_mail': 0x1f4ed,
    \ 'male-artist': [0x1f468, 0x200d, 0x1f3a8],
    \ 'male-astronaut': [0x1f468, 0x200d, 0x1f680],
    \ 'male-construction-worker': [0x1f477, 0x200d, 0x2642],
    \ 'male-cook': [0x1f468, 0x200d, 0x1f373],
    \ 'male-detective': [0x1f575, 0xfe0f, 0x200d, 0x2642],
    \ 'male-doctor': [0x1f468, 0x200d, 0x2695],
    \ 'male-factory-worker': [0x1f468, 0x200d, 0x1f3ed],
    \ 'male-farmer': [0x1f468, 0x200d, 0x1f33e],
    \ 'male-firefighter': [0x1f468, 0x200d, 0x1f692],
    \ 'male-guard': [0x1f482, 0x200d, 0x2642],
    \ 'male-judge': [0x1f468, 0x200d, 0x2696],
    \ 'male-mechanic': [0x1f468, 0x200d, 0x1f527],
    \ 'male-office-worker': [0x1f468, 0x200d, 0x1f4bc],
    \ 'male-pilot': [0x1f468, 0x200d, 0x2708],
    \ 'male-police-officer': [0x1f46e, 0x200d, 0x2642],
    \ 'male-scientist': [0x1f468, 0x200d, 0x1f52c],
    \ 'male-singer': [0x1f468, 0x200d, 0x1f3a4],
    \ 'male-student': [0x1f468, 0x200d, 0x1f393],
    \ 'male-teacher': [0x1f468, 0x200d, 0x1f3eb],
    \ 'male-technologist': [0x1f468, 0x200d, 0x1f4bb],
    \ 'male_elf': [0x1f9dd, 0x200d, 0x2642],
    \ 'male_fairy': [0x1f9da, 0x200d, 0x2642],
    \ 'male_genie': [0x1f9de, 0x200d, 0x2642],
    \ 'male_mage': [0x1f9d9, 0x200d, 0x2642],
    \ 'male_sign': 0x2642,
    \ 'male_vampire': [0x1f9db, 0x200d, 0x2642],
    \ 'male_zombie': [0x1f9df, 0x200d, 0x2642],
    \ 'man': 0x1f468,
    \ 'man-biking': [0x1f6b4, 0x200d, 0x2642],
    \ 'man-bouncing-ball': [0x26f9, 0xfe0f, 0x200d, 0x2642],
    \ 'man-bowing': [0x1f647, 0x200d, 0x2642],
    \ 'man-boy': [0x1f468, 0x200d, 0x1f466],
    \ 'man-boy-boy': [0x1f468, 0x200d, 0x1f466, 0x200d, 0x1f466],
    \ 'man-cartwheeling': [0x1f938, 0x200d, 0x2642],
    \ 'man-facepalming': [0x1f926, 0x200d, 0x2642],
    \ 'man-frowning': [0x1f64d, 0x200d, 0x2642],
    \ 'man-gesturing-no': [0x1f645, 0x200d, 0x2642],
    \ 'man-gesturing-ok': [0x1f646, 0x200d, 0x2642],
    \ 'man-getting-haircut': [0x1f487, 0x200d, 0x2642],
    \ 'man-getting-massage': [0x1f486, 0x200d, 0x2642],
    \ 'man-girl': [0x1f468, 0x200d, 0x1f467],
    \ 'man-girl-boy': [0x1f468, 0x200d, 0x1f467, 0x200d, 0x1f466],
    \ 'man-girl-girl': [0x1f468, 0x200d, 0x1f467, 0x200d, 0x1f467],
    \ 'man-golfing': [0x1f3cc, 0xfe0f, 0x200d, 0x2642],
    \ 'man-heart-man': [0x1f468, 0x200d, 0x2764, 0xfe0f, 0x200d, 0x1f468],
    \ 'man-juggling': [0x1f939, 0x200d, 0x2642],
    \ 'man-kiss-man': [0x1f468, 0x200d, 0x2764, 0xfe0f, 0x200d, 0x1f48b, 0x200d, 0x1f468],
    \ 'man-lifting-weights': [0x1f3cb, 0xfe0f, 0x200d, 0x2642],
    \ 'man-man-boy': [0x1f468, 0x200d, 0x1f468, 0x200d, 0x1f466],
    \ 'man-man-boy-boy': [0x1f468, 0x200d, 0x1f468, 0x200d, 0x1f466, 0x200d, 0x1f466],
    \ 'man-man-girl': [0x1f468, 0x200d, 0x1f468, 0x200d, 0x1f467],
    \ 'man-man-girl-boy': [0x1f468, 0x200d, 0x1f468, 0x200d, 0x1f467, 0x200d, 0x1f466],
    \ 'man-man-girl-girl': [0x1f468, 0x200d, 0x1f468, 0x200d, 0x1f467, 0x200d, 0x1f467],
    \ 'man-mountain-biking': [0x1f6b5, 0x200d, 0x2642],
    \ 'man-playing-handball': [0x1f93e, 0x200d, 0x2642],
    \ 'man-playing-water-polo': [0x1f93d, 0x200d, 0x2642],
    \ 'man-pouting': [0x1f64e, 0x200d, 0x2642],
    \ 'man-raising-hand': [0x1f64b, 0x200d, 0x2642],
    \ 'man-rowing-boat': [0x1f6a3, 0x200d, 0x2642],
    \ 'man-running': [0x1f3c3, 0x200d, 0x2642],
    \ 'man-shrugging': [0x1f937, 0x200d, 0x2642],
    \ 'man-surfing': [0x1f3c4, 0x200d, 0x2642],
    \ 'man-swimming': [0x1f3ca, 0x200d, 0x2642],
    \ 'man-tipping-hand': [0x1f481, 0x200d, 0x2642],
    \ 'man-walking': [0x1f6b6, 0x200d, 0x2642],
    \ 'man-wearing-turban': [0x1f473, 0x200d, 0x2642],
    \ 'man-with-bunny-ears-partying': [0x1f46f, 0x200d, 0x2642],
    \ 'man-woman-boy': [0x1f468, 0x200d, 0x1f469, 0x200d, 0x1f466],
    \ 'man-woman-boy-boy': [0x1f468, 0x200d, 0x1f469, 0x200d, 0x1f466, 0x200d, 0x1f466],
    \ 'man-woman-girl': [0x1f468, 0x200d, 0x1f469, 0x200d, 0x1f467],
    \ 'man-woman-girl-boy': [0x1f468, 0x200d, 0x1f469, 0x200d, 0x1f467, 0x200d, 0x1f466],
    \ 'man-woman-girl-girl': [0x1f468, 0x200d, 0x1f469, 0x200d, 0x1f467, 0x200d, 0x1f467],
    \ 'man-wrestling': [0x1f93c, 0x200d, 0x2642],
    \ 'man_climbing': [0x1f9d7, 0x200d, 0x2642],
    \ 'man_dancing': 0x1f57a,
    \ 'man_in_business_suit_levitating': 0x1f574,
    \ 'man_in_lotus_position': [0x1f9d8, 0x200d, 0x2642],
    \ 'man_in_steamy_room': [0x1f9d6, 0x200d, 0x2642],
    \ 'man_in_tuxedo': 0x1f935,
    \ 'man_with_gua_pi_mao': 0x1f472,
    \ 'man_with_turban': 0x1f473,
    \ 'mans_shoe': 0x1f45e,
    \ 'mantelpiece_clock': 0x1f570,
    \ 'maple_leaf': 0x1f341,
    \ 'martial_arts_uniform': 0x1f94b,
    \ 'mask': 0x1f637,
    \ 'massage': 0x1f486,
    \ 'meat_on_bone': 0x1f356,
    \ 'medal': 0x1f396,
    \ 'mega': 0x1f4e3,
    \ 'melon': 0x1f348,
    \ 'memo': 0x1f4dd,
    \ 'menorah_with_nine_branches': 0x1f54e,
    \ 'mens': 0x1f6b9,
    \ 'mermaid': [0x1f9dc, 0x200d, 0x2640],
    \ 'merman': [0x1f9dc, 0x200d, 0x2642],
    \ 'merperson': 0x1f9dc,
    \ 'metro': 0x1f687,
    \ 'microphone': 0x1f3a4,
    \ 'microscope': 0x1f52c,
    \ 'middle_finger': 0x1f595,
    \ 'milky_way': 0x1f30c,
    \ 'minibus': 0x1f690,
    \ 'minidisc': 0x1f4bd,
    \ 'mobile_phone_off': 0x1f4f4,
    \ 'money_mouth_face': 0x1f911,
    \ 'money_with_wings': 0x1f4b8,
    \ 'moneybag': 0x1f4b0,
    \ 'monkey': 0x1f412,
    \ 'monkey_face': 0x1f435,
    \ 'monorail': 0x1f69d,
    \ 'moon': 0x1f314,
    \ 'mortar_board': 0x1f393,
    \ 'mosque': 0x1f54c,
    \ 'mostly_sunny': 0x1f324,
    \ 'mother_christmas': 0x1f936,
    \ 'motor_boat': 0x1f6e5,
    \ 'motor_scooter': 0x1f6f5,
    \ 'motorway': 0x1f6e3,
    \ 'mount_fuji': 0x1f5fb,
    \ 'mountain': 0x26f0,
    \ 'mountain_bicyclist': 0x1f6b5,
    \ 'mountain_cableway': 0x1f6a0,
    \ 'mountain_railway': 0x1f69e,
    \ 'mouse': 0x1f42d,
    \ 'mouse2': 0x1f401,
    \ 'movie_camera': 0x1f3a5,
    \ 'moyai': 0x1f5ff,
    \ 'muscle': 0x1f4aa,
    \ 'mushroom': 0x1f344,
    \ 'musical_keyboard': 0x1f3b9,
    \ 'musical_note': 0x1f3b5,
    \ 'musical_score': 0x1f3bc,
    \ 'mute': 0x1f507,
    \ 'nail_care': 0x1f485,
    \ 'name_badge': 0x1f4db,
    \ 'national_park': 0x1f3de,
    \ 'nauseated_face': 0x1f922,
    \ 'necktie': 0x1f454,
    \ 'negative_squared_cross_mark': 0x274e,
    \ 'nerd_face': 0x1f913,
    \ 'neutral_face': 0x1f610,
    \ 'new': 0x1f195,
    \ 'new_moon': 0x1f311,
    \ 'new_moon_with_face': 0x1f31a,
    \ 'newspaper': 0x1f4f0,
    \ 'ng': 0x1f196,
    \ 'night_with_stars': 0x1f303,
    \ 'nine': 0x0039,
    \ 'no_bell': 0x1f515,
    \ 'no_bicycles': 0x1f6b3,
    \ 'no_entry': 0x26d4,
    \ 'no_entry_sign': 0x1f6ab,
    \ 'no_good': 0x1f645,
    \ 'no_mobile_phones': 0x1f4f5,
    \ 'no_mouth': 0x1f636,
    \ 'no_pedestrians': 0x1f6b7,
    \ 'no_smoking': 0x1f6ad,
    \ 'non-potable_water': 0x1f6b1,
    \ 'nose': 0x1f443,
    \ 'notebook': 0x1f4d3,
    \ 'notebook_with_decorative_cover': 0x1f4d4,
    \ 'notes': 0x1f3b6,
    \ 'nut_and_bolt': 0x1f529,
    \ 'o': 0x2b55,
    \ 'o2': 0x1f17e,
    \ 'ocean': 0x1f30a,
    \ 'octagonal_sign': 0x1f6d1,
    \ 'octopus': 0x1f419,
    \ 'oden': 0x1f362,
    \ 'office': 0x1f3e2,
    \ 'oil_drum': 0x1f6e2,
    \ 'ok': 0x1f197,
    \ 'ok_hand': 0x1f44c,
    \ 'ok_woman': 0x1f646,
    \ 'old_key': 0x1f5dd,
    \ 'older_adult': 0x1f9d3,
    \ 'older_man': 0x1f474,
    \ 'older_woman': 0x1f475,
    \ 'om_symbol': 0x1f549,
    \ 'on': 0x1f51b,
    \ 'oncoming_automobile': 0x1f698,
    \ 'oncoming_bus': 0x1f68d,
    \ 'oncoming_police_car': 0x1f694,
    \ 'oncoming_taxi': 0x1f696,
    \ 'one': 0x0031,
    \ 'open_book': 0x1f4d6,
    \ 'open_file_folder': 0x1f4c2,
    \ 'open_hands': 0x1f450,
    \ 'open_mouth': 0x1f62e,
    \ 'ophiuchus': 0x26ce,
    \ 'orange_book': 0x1f4d9,
    \ 'orange_heart': 0x1f9e1,
    \ 'orthodox_cross': 0x2626,
    \ 'outbox_tray': 0x1f4e4,
    \ 'owl': 0x1f989,
    \ 'ox': 0x1f402,
    \ 'package': 0x1f4e6,
    \ 'page_facing_up': 0x1f4c4,
    \ 'page_with_curl': 0x1f4c3,
    \ 'pager': 0x1f4df,
    \ 'palm_tree': 0x1f334,
    \ 'palms_up_together': 0x1f932,
    \ 'pancakes': 0x1f95e,
    \ 'panda_face': 0x1f43c,
    \ 'paperclip': 0x1f4ce,
    \ 'parking': 0x1f17f,
    \ 'part_alternation_mark': 0x303d,
    \ 'partly_sunny': 0x26c5,
    \ 'partly_sunny_rain': 0x1f326,
    \ 'passenger_ship': 0x1f6f3,
    \ 'passport_control': 0x1f6c2,
    \ 'paw_prints': 0x1f43e,
    \ 'peace_symbol': 0x262e,
    \ 'peach': 0x1f351,
    \ 'peanuts': 0x1f95c,
    \ 'pear': 0x1f350,
    \ 'pencil': 0x1f4dd,
    \ 'pencil2': 0x270f,
    \ 'penguin': 0x1f427,
    \ 'pensive': 0x1f614,
    \ 'performing_arts': 0x1f3ad,
    \ 'persevere': 0x1f623,
    \ 'person_climbing': 0x1f9d7,
    \ 'person_doing_cartwheel': 0x1f938,
    \ 'person_frowning': 0x1f64d,
    \ 'person_in_lotus_position': 0x1f9d8,
    \ 'person_in_steamy_room': 0x1f9d6,
    \ 'person_with_ball': 0x26f9,
    \ 'person_with_blond_hair': 0x1f471,
    \ 'person_with_headscarf': 0x1f9d5,
    \ 'person_with_pouting_face': 0x1f64e,
    \ 'phone': 0x260e,
    \ 'pick': 0x26cf,
    \ 'pie': 0x1f967,
    \ 'pig': 0x1f437,
    \ 'pig2': 0x1f416,
    \ 'pig_nose': 0x1f43d,
    \ 'pill': 0x1f48a,
    \ 'pineapple': 0x1f34d,
    \ 'pisces': 0x2653,
    \ 'pizza': 0x1f355,
    \ 'place_of_worship': 0x1f6d0,
    \ 'point_down': 0x1f447,
    \ 'point_left': 0x1f448,
    \ 'point_right': 0x1f449,
    \ 'point_up': 0x261d,
    \ 'point_up_2': 0x1f446,
    \ 'police_car': 0x1f693,
    \ 'poodle': 0x1f429,
    \ 'poop': 0x1f4a9,
    \ 'popcorn': 0x1f37f,
    \ 'post_office': 0x1f3e3,
    \ 'postal_horn': 0x1f4ef,
    \ 'postbox': 0x1f4ee,
    \ 'potable_water': 0x1f6b0,
    \ 'potato': 0x1f954,
    \ 'pouch': 0x1f45d,
    \ 'poultry_leg': 0x1f357,
    \ 'pound': 0x1f4b7,
    \ 'pouting_cat': 0x1f63e,
    \ 'pray': 0x1f64f,
    \ 'prayer_beads': 0x1f4ff,
    \ 'pregnant_woman': 0x1f930,
    \ 'pretzel': 0x1f968,
    \ 'prince': 0x1f934,
    \ 'princess': 0x1f478,
    \ 'printer': 0x1f5a8,
    \ 'punch': 0x1f44a,
    \ 'purple_heart': 0x1f49c,
    \ 'purse': 0x1f45b,
    \ 'pushpin': 0x1f4cc,
    \ 'put_litter_in_its_place': 0x1f6ae,
    \ 'question': 0x2753,
    \ 'rabbit': 0x1f430,
    \ 'rabbit2': 0x1f407,
    \ 'racehorse': 0x1f40e,
    \ 'racing_car': 0x1f3ce,
    \ 'racing_motorcycle': 0x1f3cd,
    \ 'radio': 0x1f4fb,
    \ 'radio_button': 0x1f518,
    \ 'radioactive_sign': 0x2622,
    \ 'rage': 0x1f621,
    \ 'railway_car': 0x1f683,
    \ 'railway_track': 0x1f6e4,
    \ 'rain_cloud': 0x1f327,
    \ 'rainbow': 0x1f308,
    \ 'rainbow-flag': [0x1f3f3, 0xfe0f, 0x200d, 0x1f308],
    \ 'raised_back_of_hand': 0x1f91a,
    \ 'raised_hand': 0x270b,
    \ 'raised_hand_with_fingers_splayed': 0x1f590,
    \ 'raised_hands': 0x1f64c,
    \ 'raising_hand': 0x1f64b,
    \ 'ram': 0x1f40f,
    \ 'ramen': 0x1f35c,
    \ 'rat': 0x1f400,
    \ 'recycle': 0x267b,
    \ 'red_car': 0x1f697,
    \ 'red_circle': 0x1f534,
    \ 'registered': 0x00ae,
    \ 'relaxed': 0x263a,
    \ 'relieved': 0x1f60c,
    \ 'reminder_ribbon': 0x1f397,
    \ 'repeat': 0x1f501,
    \ 'repeat_one': 0x1f502,
    \ 'restroom': 0x1f6bb,
    \ 'revolving_hearts': 0x1f49e,
    \ 'rewind': 0x23ea,
    \ 'rhinoceros': 0x1f98f,
    \ 'ribbon': 0x1f380,
    \ 'rice': 0x1f35a,
    \ 'rice_ball': 0x1f359,
    \ 'rice_cracker': 0x1f358,
    \ 'rice_scene': 0x1f391,
    \ 'right-facing_fist': 0x1f91c,
    \ 'right_anger_bubble': 0x1f5ef,
    \ 'ring': 0x1f48d,
    \ 'robot_face': 0x1f916,
    \ 'rocket': 0x1f680,
    \ 'rolled_up_newspaper': 0x1f5de,
    \ 'roller_coaster': 0x1f3a2,
    \ 'rolling_on_the_floor_laughing': 0x1f923,
    \ 'rooster': 0x1f413,
    \ 'rose': 0x1f339,
    \ 'rosette': 0x1f3f5,
    \ 'rotating_light': 0x1f6a8,
    \ 'round_pushpin': 0x1f4cd,
    \ 'rowboat': 0x1f6a3,
    \ 'ru': [0x1f1f7, 0x1f1fa],
    \ 'rugby_football': 0x1f3c9,
    \ 'runner': 0x1f3c3,
    \ 'running': 0x1f3c3,
    \ 'running_shirt_with_sash': 0x1f3bd,
    \ 'sa': 0x1f202,
    \ 'sagittarius': 0x2650,
    \ 'sailboat': 0x26f5,
    \ 'sake': 0x1f376,
    \ 'sandal': 0x1f461,
    \ 'sandwich': 0x1f96a,
    \ 'santa': 0x1f385,
    \ 'satellite': 0x1f4e1,
    \ 'satellite_antenna': 0x1f4e1,
    \ 'satisfied': 0x1f606,
    \ 'sauropod': 0x1f995,
    \ 'saxophone': 0x1f3b7,
    \ 'scales': 0x2696,
    \ 'scarf': 0x1f9e3,
    \ 'school': 0x1f3eb,
    \ 'school_satchel': 0x1f392,
    \ 'scissors': 0x2702,
    \ 'scooter': 0x1f6f4,
    \ 'scorpion': 0x1f982,
    \ 'scorpius': 0x264f,
    \ 'scream': 0x1f631,
    \ 'scream_cat': 0x1f640,
    \ 'scroll': 0x1f4dc,
    \ 'seat': 0x1f4ba,
    \ 'second_place_medal': 0x1f948,
    \ 'secret': 0x3299,
    \ 'see_no_evil': 0x1f648,
    \ 'seedling': 0x1f331,
    \ 'selfie': 0x1f933,
    \ 'serious_face_with_symbols_covering_mouth': 0x1f92c,
    \ 'seven': 0x0037,
    \ 'shallow_pan_of_food': 0x1f958,
    \ 'shamrock': 0x2618,
    \ 'shark': 0x1f988,
    \ 'shaved_ice': 0x1f367,
    \ 'sheep': 0x1f411,
    \ 'shell': 0x1f41a,
    \ 'shield': 0x1f6e1,
    \ 'shinto_shrine': 0x26e9,
    \ 'ship': 0x1f6a2,
    \ 'shirt': 0x1f455,
    \ 'shit': 0x1f4a9,
    \ 'shocked_face_with_exploding_head': 0x1f92f,
    \ 'shoe': 0x1f45e,
    \ 'shopping_bags': 0x1f6cd,
    \ 'shopping_trolley': 0x1f6d2,
    \ 'shower': 0x1f6bf,
    \ 'shrimp': 0x1f990,
    \ 'shrug': 0x1f937,
    \ 'signal_strength': 0x1f4f6,
    \ 'six': 0x0036,
    \ 'six_pointed_star': 0x1f52f,
    \ 'ski': 0x1f3bf,
    \ 'skier': 0x26f7,
    \ 'skin-tone-2': 0x1f3fb,
    \ 'skin-tone-3': 0x1f3fc,
    \ 'skin-tone-4': 0x1f3fd,
    \ 'skin-tone-5': 0x1f3fe,
    \ 'skin-tone-6': 0x1f3ff,
    \ 'skull': 0x1f480,
    \ 'skull_and_crossbones': 0x2620,
    \ 'sled': 0x1f6f7,
    \ 'sleeping': 0x1f634,
    \ 'sleeping_accommodation': 0x1f6cc,
    \ 'sleepy': 0x1f62a,
    \ 'sleuth_or_spy': 0x1f575,
    \ 'slightly_frowning_face': 0x1f641,
    \ 'slightly_smiling_face': 0x1f642,
    \ 'slot_machine': 0x1f3b0,
    \ 'small_airplane': 0x1f6e9,
    \ 'small_blue_diamond': 0x1f539,
    \ 'small_orange_diamond': 0x1f538,
    \ 'small_red_triangle': 0x1f53a,
    \ 'small_red_triangle_down': 0x1f53b,
    \ 'smile': 0x1f604,
    \ 'smile_cat': 0x1f638,
    \ 'smiley': 0x1f603,
    \ 'smiley_cat': 0x1f63a,
    \ 'smiling_face_with_smiling_eyes_and_hand_covering_mouth': 0x1f92d,
    \ 'smiling_imp': 0x1f608,
    \ 'smirk': 0x1f60f,
    \ 'smirk_cat': 0x1f63c,
    \ 'smoking': 0x1f6ac,
    \ 'snail': 0x1f40c,
    \ 'snake': 0x1f40d,
    \ 'sneezing_face': 0x1f927,
    \ 'snow_capped_mountain': 0x1f3d4,
    \ 'snow_cloud': 0x1f328,
    \ 'snowboarder': 0x1f3c2,
    \ 'snowflake': 0x2744,
    \ 'snowman': 0x26c4,
    \ 'snowman_without_snow': 0x26c4,
    \ 'sob': 0x1f62d,
    \ 'soccer': 0x26bd,
    \ 'socks': 0x1f9e6,
    \ 'soon': 0x1f51c,
    \ 'sos': 0x1f198,
    \ 'sound': 0x1f509,
    \ 'space_invader': 0x1f47e,
    \ 'spades': 0x2660,
    \ 'spaghetti': 0x1f35d,
    \ 'sparkle': 0x2747,
    \ 'sparkler': 0x1f387,
    \ 'sparkles': 0x2728,
    \ 'sparkling_heart': 0x1f496,
    \ 'speak_no_evil': 0x1f64a,
    \ 'speaker': 0x1f50a,
    \ 'speaking_head_in_silhouette': 0x1f5e3,
    \ 'speech_balloon': 0x1f4ac,
    \ 'speedboat': 0x1f6a4,
    \ 'spider': 0x1f577,
    \ 'spider_web': 0x1f578,
    \ 'spiral_calendar_pad': 0x1f5d3,
    \ 'spiral_note_pad': 0x1f5d2,
    \ 'spock-hand': 0x1f596,
    \ 'spoon': 0x1f944,
    \ 'sports_medal': 0x1f3c5,
    \ 'squid': 0x1f991,
    \ 'stadium': 0x1f3df,
    \ 'staff_of_aesculapius': 0x2695,
    \ 'star': 0x2b50,
    \ 'star2': 0x1f31f,
    \ 'star_and_crescent': 0x262a,
    \ 'star_of_david': 0x2721,
    \ 'stars': 0x1f303,
    \ 'station': 0x1f689,
    \ 'statue_of_liberty': 0x1f5fd,
    \ 'steam_locomotive': 0x1f682,
    \ 'stew': 0x1f372,
    \ 'stopwatch': 0x23f1,
    \ 'straight_ruler': 0x1f4cf,
    \ 'strawberry': 0x1f353,
    \ 'stuck_out_tongue': 0x1f61b,
    \ 'stuck_out_tongue_closed_eyes': 0x1f61d,
    \ 'stuck_out_tongue_winking_eye': 0x1f61c,
    \ 'studio_microphone': 0x1f399,
    \ 'stuffed_flatbread': 0x1f959,
    \ 'sun_with_face': 0x1f31e,
    \ 'sunflower': 0x1f33b,
    \ 'sunglasses': 0x1f60e,
    \ 'sunny': 0x2600,
    \ 'sunrise': 0x1f305,
    \ 'sunrise_over_mountains': 0x1f304,
    \ 'surfer': 0x1f3c4,
    \ 'sushi': 0x1f363,
    \ 'suspension_railway': 0x1f69f,
    \ 'sweat': 0x1f613,
    \ 'sweat_drops': 0x1f4a6,
    \ 'sweat_smile': 0x1f605,
    \ 'sweet_potato': 0x1f360,
    \ 'swimmer': 0x1f3ca,
    \ 'symbols': 0x1f523,
    \ 'synagogue': 0x1f54d,
    \ 'syringe': 0x1f489,
    \ 't-rex': 0x1f996,
    \ 'table_tennis_paddle_and_ball': 0x1f3d3,
    \ 'taco': 0x1f32e,
    \ 'tada': 0x1f389,
    \ 'takeout_box': 0x1f961,
    \ 'tanabata_tree': 0x1f38b,
    \ 'tangerine': 0x1f34a,
    \ 'taurus': 0x2649,
    \ 'taxi': 0x1f695,
    \ 'tea': 0x1f375,
    \ 'telephone': 0x260e,
    \ 'telephone_receiver': 0x1f4de,
    \ 'telescope': 0x1f52d,
    \ 'tennis': 0x1f3be,
    \ 'tent': 0x26fa,
    \ 'the_horns': 0x1f918,
    \ 'thermometer': 0x1f321,
    \ 'thinking_face': 0x1f914,
    \ 'third_place_medal': 0x1f949,
    \ 'thought_balloon': 0x1f4ad,
    \ 'three': 0x0033,
    \ 'three_button_mouse': 0x1f5b1,
    \ 'thumbsdown': 0x1f44e,
    \ 'thumbsup': 0x1f44d,
    \ 'thunder_cloud_and_rain': 0x26c8,
    \ 'ticket': 0x1f3ab,
    \ 'tiger': 0x1f42f,
    \ 'tiger2': 0x1f405,
    \ 'timer_clock': 0x23f2,
    \ 'tired_face': 0x1f62b,
    \ 'tm': 0x2122,
    \ 'toilet': 0x1f6bd,
    \ 'tokyo_tower': 0x1f5fc,
    \ 'tomato': 0x1f345,
    \ 'tongue': 0x1f445,
    \ 'top': 0x1f51d,
    \ 'tophat': 0x1f3a9,
    \ 'tornado': 0x1f32a,
    \ 'trackball': 0x1f5b2,
    \ 'tractor': 0x1f69c,
    \ 'traffic_light': 0x1f6a5,
    \ 'train': 0x1f683,
    \ 'train2': 0x1f686,
    \ 'tram': 0x1f68a,
    \ 'triangular_flag_on_post': 0x1f6a9,
    \ 'triangular_ruler': 0x1f4d0,
    \ 'trident': 0x1f531,
    \ 'triumph': 0x1f624,
    \ 'trolleybus': 0x1f68e,
    \ 'trophy': 0x1f3c6,
    \ 'tropical_drink': 0x1f379,
    \ 'tropical_fish': 0x1f420,
    \ 'truck': 0x1f69a,
    \ 'trumpet': 0x1f3ba,
    \ 'tshirt': 0x1f455,
    \ 'tulip': 0x1f337,
    \ 'tumbler_glass': 0x1f943,
    \ 'turkey': 0x1f983,
    \ 'turtle': 0x1f422,
    \ 'tv': 0x1f4fa,
    \ 'twisted_rightwards_arrows': 0x1f500,
    \ 'two': 0x0032,
    \ 'two_hearts': 0x1f495,
    \ 'two_men_holding_hands': 0x1f46c,
    \ 'two_women_holding_hands': 0x1f46d,
    \ 'u5272': 0x1f239,
    \ 'u5408': 0x1f234,
    \ 'u55b6': 0x1f23a,
    \ 'u6307': 0x1f22f,
    \ 'u6708': 0x1f237,
    \ 'u6709': 0x1f236,
    \ 'u6e80': 0x1f235,
    \ 'u7121': 0x1f21a,
    \ 'u7533': 0x1f238,
    \ 'u7981': 0x1f232,
    \ 'u7a7a': 0x1f233,
    \ 'uk': [0x1f1ec, 0x1f1e7],
    \ 'umbrella': 0x2614,
    \ 'umbrella_on_ground': 0x26f1,
    \ 'umbrella_with_rain_drops': 0x2614,
    \ 'unamused': 0x1f612,
    \ 'underage': 0x1f51e,
    \ 'unicorn_face': 0x1f984,
    \ 'unlock': 0x1f513,
    \ 'up': 0x1f199,
    \ 'upside_down_face': 0x1f643,
    \ 'us': [0x1f1fa, 0x1f1f8],
    \ 'v': 0x270c,
    \ 'vampire': 0x1f9db,
    \ 'vertical_traffic_light': 0x1f6a6,
    \ 'vhs': 0x1f4fc,
    \ 'vibration_mode': 0x1f4f3,
    \ 'video_camera': 0x1f4f9,
    \ 'video_game': 0x1f3ae,
    \ 'violin': 0x1f3bb,
    \ 'virgo': 0x264d,
    \ 'volcano': 0x1f30b,
    \ 'volleyball': 0x1f3d0,
    \ 'vs': 0x1f19a,
    \ 'walking': 0x1f6b6,
    \ 'waning_crescent_moon': 0x1f318,
    \ 'waning_gibbous_moon': 0x1f316,
    \ 'warning': 0x26a0,
    \ 'wastebasket': 0x1f5d1,
    \ 'watch': 0x231a,
    \ 'water_buffalo': 0x1f403,
    \ 'water_polo': 0x1f93d,
    \ 'watermelon': 0x1f349,
    \ 'wave': 0x1f44b,
    \ 'waving_black_flag': 0x1f3f4,
    \ 'waving_white_flag': 0x1f3f3,
    \ 'wavy_dash': 0x3030,
    \ 'waxing_crescent_moon': 0x1f312,
    \ 'waxing_gibbous_moon': 0x1f314,
    \ 'wc': 0x1f6be,
    \ 'weary': 0x1f629,
    \ 'wedding': 0x1f492,
    \ 'weight_lifter': 0x1f3cb,
    \ 'whale': 0x1f433,
    \ 'whale2': 0x1f40b,
    \ 'wheel_of_dharma': 0x2638,
    \ 'wheelchair': 0x267f,
    \ 'white_check_mark': 0x2705,
    \ 'white_circle': 0x26aa,
    \ 'white_flower': 0x1f4ae,
    \ 'white_frowning_face': 0x2639,
    \ 'white_large_square': 0x2b1c,
    \ 'white_medium_small_square': 0x25fd,
    \ 'white_medium_square': 0x25fb,
    \ 'white_small_square': 0x25ab,
    \ 'white_square_button': 0x1f533,
    \ 'wilted_flower': 0x1f940,
    \ 'wind_blowing_face': 0x1f32c,
    \ 'wind_chime': 0x1f390,
    \ 'wine_glass': 0x1f377,
    \ 'wink': 0x1f609,
    \ 'wolf': 0x1f43a,
    \ 'woman': 0x1f469,
    \ 'woman-biking': [0x1f6b4, 0x200d, 0x2640],
    \ 'woman-bouncing-ball': [0x26f9, 0xfe0f, 0x200d, 0x2640],
    \ 'woman-bowing': [0x1f647, 0x200d, 0x2640],
    \ 'woman-boy': [0x1f469, 0x200d, 0x1f466],
    \ 'woman-boy-boy': [0x1f469, 0x200d, 0x1f466, 0x200d, 0x1f466],
    \ 'woman-cartwheeling': [0x1f938, 0x200d, 0x2640],
    \ 'woman-facepalming': [0x1f926, 0x200d, 0x2640],
    \ 'woman-frowning': [0x1f64d, 0x200d, 0x2640],
    \ 'woman-gesturing-no': [0x1f645, 0x200d, 0x2640],
    \ 'woman-gesturing-ok': [0x1f646, 0x200d, 0x2640],
    \ 'woman-getting-haircut': [0x1f487, 0x200d, 0x2640],
    \ 'woman-getting-massage': [0x1f486, 0x200d, 0x2640],
    \ 'woman-girl': [0x1f469, 0x200d, 0x1f467],
    \ 'woman-girl-boy': [0x1f469, 0x200d, 0x1f467, 0x200d, 0x1f466],
    \ 'woman-girl-girl': [0x1f469, 0x200d, 0x1f467, 0x200d, 0x1f467],
    \ 'woman-golfing': [0x1f3cc, 0xfe0f, 0x200d, 0x2640],
    \ 'woman-heart-man': [0x1f469, 0x200d, 0x2764, 0xfe0f, 0x200d, 0x1f468],
    \ 'woman-heart-woman': [0x1f469, 0x200d, 0x2764, 0xfe0f, 0x200d, 0x1f469],
    \ 'woman-juggling': [0x1f939, 0x200d, 0x2640],
    \ 'woman-kiss-man': [0x1f469, 0x200d, 0x2764, 0xfe0f, 0x200d, 0x1f48b, 0x200d, 0x1f468],
    \ 'woman-kiss-woman': [0x1f469, 0x200d, 0x2764, 0xfe0f, 0x200d, 0x1f48b, 0x200d, 0x1f469],
    \ 'woman-lifting-weights': [0x1f3cb, 0xfe0f, 0x200d, 0x2640],
    \ 'woman-mountain-biking': [0x1f6b5, 0x200d, 0x2640],
    \ 'woman-playing-handball': [0x1f93e, 0x200d, 0x2640],
    \ 'woman-playing-water-polo': [0x1f93d, 0x200d, 0x2640],
    \ 'woman-pouting': [0x1f64e, 0x200d, 0x2640],
    \ 'woman-raising-hand': [0x1f64b, 0x200d, 0x2640],
    \ 'woman-rowing-boat': [0x1f6a3, 0x200d, 0x2640],
    \ 'woman-running': [0x1f3c3, 0x200d, 0x2640],
    \ 'woman-shrugging': [0x1f937, 0x200d, 0x2640],
    \ 'woman-surfing': [0x1f3c4, 0x200d, 0x2640],
    \ 'woman-swimming': [0x1f3ca, 0x200d, 0x2640],
    \ 'woman-tipping-hand': [0x1f481, 0x200d, 0x2640],
    \ 'woman-walking': [0x1f6b6, 0x200d, 0x2640],
    \ 'woman-wearing-turban': [0x1f473, 0x200d, 0x2640],
    \ 'woman-with-bunny-ears-partying': [0x1f46f, 0x200d, 0x2640],
    \ 'woman-woman-boy': [0x1f469, 0x200d, 0x1f469, 0x200d, 0x1f466],
    \ 'woman-woman-boy-boy': [0x1f469, 0x200d, 0x1f469, 0x200d, 0x1f466, 0x200d, 0x1f466],
    \ 'woman-woman-girl': [0x1f469, 0x200d, 0x1f469, 0x200d, 0x1f467],
    \ 'woman-woman-girl-boy': [0x1f469, 0x200d, 0x1f469, 0x200d, 0x1f467, 0x200d, 0x1f466],
    \ 'woman-woman-girl-girl': [0x1f469, 0x200d, 0x1f469, 0x200d, 0x1f467, 0x200d, 0x1f467],
    \ 'woman-wrestling': [0x1f93c, 0x200d, 0x2640],
    \ 'woman_climbing': [0x1f9d7, 0x200d, 0x2640],
    \ 'woman_in_lotus_position': [0x1f9d8, 0x200d, 0x2640],
    \ 'woman_in_steamy_room': [0x1f9d6, 0x200d, 0x2640],
    \ 'womans_clothes': 0x1f45a,
    \ 'womans_hat': 0x1f452,
    \ 'womens': 0x1f6ba,
    \ 'world_map': 0x1f5fa,
    \ 'worried': 0x1f61f,
    \ 'wrench': 0x1f527,
    \ 'wrestlers': 0x1f93c,
    \ 'writing_hand': 0x270d,
    \ 'x': 0x274c,
    \ 'yellow_heart': 0x1f49b,
    \ 'yen': 0x1f4b4,
    \ 'yin_yang': 0x262f,
    \ 'yum': 0x1f60b,
    \ 'zap': 0x26a1,
    \ 'zebra_face': 0x1f993,
    \ 'zero': 0x0030,
    \ 'zipper_mouth_face': 0x1f910,
    \ 'zombie': 0x1f9df,
    \ 'zzz': 0x1f4a4
\ }

function! emoji#data#dict()
  return s:emoji_code
endfunction

